#ifndef Application_h
#define Application_h


#include "rti_me_c.h"
#include "osapi/osapi_semaphore.h"
#ifdef __ANDROID__
#include <android/log.h>
#include <android_native_app_glue.h>
#include <EGL/egl.h>
#include <GLES/gl.h>
#endif
struct Application {
    DDS_DomainParticipant *participant;
    char topic_name[255];
    char type_name[255];
    DDS_Long sleep_time;
    DDS_Long count;
    DDS_Topic *topic;
    OSAPI_Semaphore_T *ready_sem;
    OSAPI_Semaphore_T *data_sem;
    RTI_BOOL exit_app;
    RTI_BOOL wait_for_ready;
#ifdef __ANDROID__
    EGLDisplay display;
    EGLSurface surface;
    EGLContext context;
#endif
    struct android_app* android_state;
};

#ifndef __ANDROID__
struct android_app;
#endif

extern void 
Application_help(char *appname);

extern struct Application*
Application_create(struct android_app* android_state,
                   const char *local_participant_name,
                   const char *remote_participant_name,
                   DDS_Long domain_id, char *udp_intf, char *peer,
                   DDS_Long sleep_time, DDS_Long count);

extern DDS_ReturnCode_t
Application_enable(struct Application *application);

extern void
Application_delete(struct Application *application);

void
Application_printf(const char *format,...);

extern void
Application_set_screen_color(struct Application *application,
                             DDS_Long red,DDS_Long green,DDS_Long blue);

#endif
